=== debian/changelog ===
opentelemetry-cpp (1.23.0-2) unstable; urgency=medium

  * Team upload.
  * Link with -latomic as needed, fixing the build on armel.

 -- Colin Watson <cjwatson@debian.org>  Mon, 29 Sep 2025 19:38:13 +0100

opentelemetry-cpp (1.23.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Colin Watson <cjwatson@debian.org>  Sun, 28 Sep 2025 15:02:08 +0100
